//#line 2 "/opt/ros/diamondback/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the image_rotate package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __image_rotate__IMAGEROTATECONFIG_H__
#define __image_rotate__IMAGEROTATECONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace image_rotate
{
  class ImageRotateConfigStatics;
  
  class ImageRotateConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(ImageRotateConfig &config, const ImageRotateConfig &max, const ImageRotateConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const ImageRotateConfig &config1, const ImageRotateConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, ImageRotateConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const ImageRotateConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, ImageRotateConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const ImageRotateConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T ImageRotateConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (ImageRotateConfig::* field);

      virtual void clamp(ImageRotateConfig &config, const ImageRotateConfig &max, const ImageRotateConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const ImageRotateConfig &config1, const ImageRotateConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, ImageRotateConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const ImageRotateConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, ImageRotateConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const ImageRotateConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 41 "../cfg/ImageRotate.cfg"
      std::string target_frame_id;
//#line 42 "../cfg/ImageRotate.cfg"
      double target_x;
//#line 43 "../cfg/ImageRotate.cfg"
      double target_y;
//#line 44 "../cfg/ImageRotate.cfg"
      double target_z;
//#line 46 "../cfg/ImageRotate.cfg"
      std::string source_frame_id;
//#line 47 "../cfg/ImageRotate.cfg"
      double source_x;
//#line 48 "../cfg/ImageRotate.cfg"
      double source_y;
//#line 49 "../cfg/ImageRotate.cfg"
      double source_z;
//#line 51 "../cfg/ImageRotate.cfg"
      std::string output_frame_id;
//#line 52 "../cfg/ImageRotate.cfg"
      std::string input_frame_id;
//#line 54 "../cfg/ImageRotate.cfg"
      bool use_camera_info;
//#line 56 "../cfg/ImageRotate.cfg"
      double max_angular_rate;
//#line 58 "../cfg/ImageRotate.cfg"
      double output_image_size;
//#line 138 "/opt/ros/diamondback/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("ImageRotateConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const ImageRotateConfig &__max__ = __getMax__();
      const ImageRotateConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const ImageRotateConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const ImageRotateConfig &__getDefault__();
    static const ImageRotateConfig &__getMax__();
    static const ImageRotateConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const ImageRotateConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void ImageRotateConfig::ParamDescription<std::string>::clamp(ImageRotateConfig &config, const ImageRotateConfig &max, const ImageRotateConfig &min) const
  {
    return;
  }

  class ImageRotateConfigStatics
  {
    friend class ImageRotateConfig;
    
    ImageRotateConfigStatics()
    {
//#line 41 "../cfg/ImageRotate.cfg"
      __min__.target_frame_id = "";
//#line 41 "../cfg/ImageRotate.cfg"
      __max__.target_frame_id = "";
//#line 41 "../cfg/ImageRotate.cfg"
      __default__.target_frame_id = "base_link";
//#line 41 "../cfg/ImageRotate.cfg"
      __param_descriptions__.push_back(ImageRotateConfig::AbstractParamDescriptionConstPtr(new ImageRotateConfig::ParamDescription<std::string>("target_frame_id", "str", 0, "Frame in which the target vector is specified. Empty means the input frame.", "", &ImageRotateConfig::target_frame_id)));
//#line 42 "../cfg/ImageRotate.cfg"
      __min__.target_x = -10.0;
//#line 42 "../cfg/ImageRotate.cfg"
      __max__.target_x = 10.0;
//#line 42 "../cfg/ImageRotate.cfg"
      __default__.target_x = 0.0;
//#line 42 "../cfg/ImageRotate.cfg"
      __param_descriptions__.push_back(ImageRotateConfig::AbstractParamDescriptionConstPtr(new ImageRotateConfig::ParamDescription<double>("target_x", "double", 0, "X coordinate of the target vector", "", &ImageRotateConfig::target_x)));
//#line 43 "../cfg/ImageRotate.cfg"
      __min__.target_y = -10.0;
//#line 43 "../cfg/ImageRotate.cfg"
      __max__.target_y = 10.0;
//#line 43 "../cfg/ImageRotate.cfg"
      __default__.target_y = 0.0;
//#line 43 "../cfg/ImageRotate.cfg"
      __param_descriptions__.push_back(ImageRotateConfig::AbstractParamDescriptionConstPtr(new ImageRotateConfig::ParamDescription<double>("target_y", "double", 0, "Y coordinate of the target vector", "", &ImageRotateConfig::target_y)));
//#line 44 "../cfg/ImageRotate.cfg"
      __min__.target_z = -10.0;
//#line 44 "../cfg/ImageRotate.cfg"
      __max__.target_z = 10.0;
//#line 44 "../cfg/ImageRotate.cfg"
      __default__.target_z = 1.0;
//#line 44 "../cfg/ImageRotate.cfg"
      __param_descriptions__.push_back(ImageRotateConfig::AbstractParamDescriptionConstPtr(new ImageRotateConfig::ParamDescription<double>("target_z", "double", 0, "Z coordinate of the target vector", "", &ImageRotateConfig::target_z)));
//#line 46 "../cfg/ImageRotate.cfg"
      __min__.source_frame_id = "";
//#line 46 "../cfg/ImageRotate.cfg"
      __max__.source_frame_id = "";
//#line 46 "../cfg/ImageRotate.cfg"
      __default__.source_frame_id = "";
//#line 46 "../cfg/ImageRotate.cfg"
      __param_descriptions__.push_back(ImageRotateConfig::AbstractParamDescriptionConstPtr(new ImageRotateConfig::ParamDescription<std::string>("source_frame_id", "str", 0, "Frame in which the source vector is specified. Empty means the input frame.", "", &ImageRotateConfig::source_frame_id)));
//#line 47 "../cfg/ImageRotate.cfg"
      __min__.source_x = -10.0;
//#line 47 "../cfg/ImageRotate.cfg"
      __max__.source_x = 10.0;
//#line 47 "../cfg/ImageRotate.cfg"
      __default__.source_x = 0.0;
//#line 47 "../cfg/ImageRotate.cfg"
      __param_descriptions__.push_back(ImageRotateConfig::AbstractParamDescriptionConstPtr(new ImageRotateConfig::ParamDescription<double>("source_x", "double", 0, "X coordinate of the direction the target should be aligned with.", "", &ImageRotateConfig::source_x)));
//#line 48 "../cfg/ImageRotate.cfg"
      __min__.source_y = -10.0;
//#line 48 "../cfg/ImageRotate.cfg"
      __max__.source_y = 10.0;
//#line 48 "../cfg/ImageRotate.cfg"
      __default__.source_y = -1.0;
//#line 48 "../cfg/ImageRotate.cfg"
      __param_descriptions__.push_back(ImageRotateConfig::AbstractParamDescriptionConstPtr(new ImageRotateConfig::ParamDescription<double>("source_y", "double", 0, "Y coordinate of the direction the target should be aligned with.", "", &ImageRotateConfig::source_y)));
//#line 49 "../cfg/ImageRotate.cfg"
      __min__.source_z = -10.0;
//#line 49 "../cfg/ImageRotate.cfg"
      __max__.source_z = 10.0;
//#line 49 "../cfg/ImageRotate.cfg"
      __default__.source_z = 0.0;
//#line 49 "../cfg/ImageRotate.cfg"
      __param_descriptions__.push_back(ImageRotateConfig::AbstractParamDescriptionConstPtr(new ImageRotateConfig::ParamDescription<double>("source_z", "double", 0, "Z coordinate of the direction the target should be aligned with.", "", &ImageRotateConfig::source_z)));
//#line 51 "../cfg/ImageRotate.cfg"
      __min__.output_frame_id = "";
//#line 51 "../cfg/ImageRotate.cfg"
      __max__.output_frame_id = "";
//#line 51 "../cfg/ImageRotate.cfg"
      __default__.output_frame_id = "";
//#line 51 "../cfg/ImageRotate.cfg"
      __param_descriptions__.push_back(ImageRotateConfig::AbstractParamDescriptionConstPtr(new ImageRotateConfig::ParamDescription<std::string>("output_frame_id", "str", 0, "Frame to publish for the image's new orientation. Empty means add '_rotated' suffix to the image frame.", "", &ImageRotateConfig::output_frame_id)));
//#line 52 "../cfg/ImageRotate.cfg"
      __min__.input_frame_id = "";
//#line 52 "../cfg/ImageRotate.cfg"
      __max__.input_frame_id = "";
//#line 52 "../cfg/ImageRotate.cfg"
      __default__.input_frame_id = "";
//#line 52 "../cfg/ImageRotate.cfg"
      __param_descriptions__.push_back(ImageRotateConfig::AbstractParamDescriptionConstPtr(new ImageRotateConfig::ParamDescription<std::string>("input_frame_id", "str", 0, "Frame to use for the original camera image. Empty means that the frame in the image or camera_info should be used depending on use_camera_info.", "", &ImageRotateConfig::input_frame_id)));
//#line 54 "../cfg/ImageRotate.cfg"
      __min__.use_camera_info = 0;
//#line 54 "../cfg/ImageRotate.cfg"
      __max__.use_camera_info = 1;
//#line 54 "../cfg/ImageRotate.cfg"
      __default__.use_camera_info = 1;
//#line 54 "../cfg/ImageRotate.cfg"
      __param_descriptions__.push_back(ImageRotateConfig::AbstractParamDescriptionConstPtr(new ImageRotateConfig::ParamDescription<bool>("use_camera_info", "bool", 0, "Indicates that the camera_info topic should be subscribed to to get the default input_frame_id. Otherwise the frame from the image message will be used.", "", &ImageRotateConfig::use_camera_info)));
//#line 56 "../cfg/ImageRotate.cfg"
      __min__.max_angular_rate = 0.0;
//#line 56 "../cfg/ImageRotate.cfg"
      __max__.max_angular_rate = 100.0;
//#line 56 "../cfg/ImageRotate.cfg"
      __default__.max_angular_rate = 10.0;
//#line 56 "../cfg/ImageRotate.cfg"
      __param_descriptions__.push_back(ImageRotateConfig::AbstractParamDescriptionConstPtr(new ImageRotateConfig::ParamDescription<double>("max_angular_rate", "double", 0, "Limits the rate at which the image can rotate (rad/s). Zero means no limit.", "", &ImageRotateConfig::max_angular_rate)));
//#line 58 "../cfg/ImageRotate.cfg"
      __min__.output_image_size = 0.0;
//#line 58 "../cfg/ImageRotate.cfg"
      __max__.output_image_size = 3.0;
//#line 58 "../cfg/ImageRotate.cfg"
      __default__.output_image_size = 2.0;
//#line 58 "../cfg/ImageRotate.cfg"
      __param_descriptions__.push_back(ImageRotateConfig::AbstractParamDescriptionConstPtr(new ImageRotateConfig::ParamDescription<double>("output_image_size", "double", 0, "Size of the output image as a function of the input image size. Can be varied continuously between the following special settings: 0 ensures no black ever appears, 1 is small image dimension, 2 is large image dimension, 3 is image diagonal.", "", &ImageRotateConfig::output_image_size)));
//#line 239 "/opt/ros/diamondback/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<ImageRotateConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<ImageRotateConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    ImageRotateConfig __max__;
    ImageRotateConfig __min__;
    ImageRotateConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const ImageRotateConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static ImageRotateConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &ImageRotateConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const ImageRotateConfig &ImageRotateConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const ImageRotateConfig &ImageRotateConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const ImageRotateConfig &ImageRotateConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<ImageRotateConfig::AbstractParamDescriptionConstPtr> &ImageRotateConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const ImageRotateConfigStatics *ImageRotateConfig::__get_statics__()
  {
    const static ImageRotateConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = ImageRotateConfigStatics::get_instance();
    
    return statics;
  }


}

#endif // __IMAGEROTATERECONFIGURATOR_H__
